My Project: dgConvexHull4d Class Reference

My Project

Public Member Functions | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
dgConvexHull4d Class Reference

`#include <dgConvexHull4d.h>`

Inheritance diagram for dgConvexHull4d:

## Public Member Functions

| dgConvexHull4d (dgMemoryAllocator *const allocator, const dgBigVector *const vertexCloud, dgInt32 count, dgFloat32 distTol)
virtual | ~dgConvexHull4d ()
dgInt32 | GetVertexCount () const
dgInt32 | GetVertexIndex (dgInt32 i) const
const dgBigVector & | GetVertex (dgInt32 i) const
const dgHullVector * | GetHullVertexArray () const
dgInt32 | IncMark ()
void | Save (const char *const filename) const
Public Member Functions inherited from dgList< dgConvexHull4dTetraherum >
| dgList (dgMemoryAllocator *const allocator)
virtual | ~dgList ()
dgMemoryAllocator * | GetAllocator () const
void | SetAllocator (dgMemoryAllocator *const allocator)
| operator dgInt32 () const
dgInt32 | GetCount () const
dgListNode * | GetLast () const
dgListNode * | GetFirst () const
dgListNode * | Append ()
dgListNode * | Append (dgListNode *const node)
dgListNode * | Append (const dgConvexHull4dTetraherum &element)
dgListNode * | Addtop ()
dgListNode * | Addtop (dgListNode *const node)
dgListNode * | Addtop (const dgConvexHull4dTetraherum &element)
void | RotateToEnd (dgListNode *const node)
void | RotateToBegin (dgListNode *const node)
void | InsertAfter (dgListNode *const root, dgListNode *const node)
void | InsertBefore (dgListNode *const root, dgListNode *const node)
dgListNode * | Find (const dgConvexHull4dTetraherum &element) const
dgListNode * | GetNodeFromInfo (dgConvexHull4dTetraherum &m_info) const
void | Remove (dgListNode *const node)
void | Remove (const dgConvexHull4dTetraherum &element)
void | RemoveAll ()
void | Merge (dgList< dgConvexHull4dTetraherum > &list)
void | Unlink (dgListNode *const node)
bool | SanityCheck () const

## Protected Member Functions

| dgConvexHull4d (dgMemoryAllocator *const allocator)
void | BuildHull (dgMemoryAllocator *const allocator, const dgBigVector *const vertexCloud, dgInt32 count, dgFloat64 distTol)
virtual dgInt32 | AddVertex (const dgBigVector &vertex)
virtual dgInt32 | InitVertexArray (dgHullVector *const points, const dgBigVector *const vertexCloud, dgInt32 count, void *const memoryPool, dgInt32 maxMemSize)
virtual dgListNode * | AddFace (dgInt32 i0, dgInt32 i1, dgInt32 i2, dgInt32 i3)
virtual void | DeleteFace (dgListNode *const node)
dgListNode * | FindFacingNode (const dgBigVector &vertex)
dgInt32 | BuildNormalList (dgBigVector *const normalArray) const
void | InsertNewVertex (dgInt32 vertexIndex, dgListNode *const frontFace, dgList< dgListNode *> &deletedFaces, dgList< dgListNode *> &newFaces)
dgInt32 | SupportVertex (dgAABBPointTree4d **const tree, const dgHullVector *const points, const dgBigVector &dir) const
void | TessellateTriangle (dgInt32 level, const dgVector &p0, const dgVector &p1, const dgVector &p2, dgInt32 &count, dgBigVector *const ouput, dgInt32 &start) const
void | CalculateConvexHull (dgAABBPointTree4d *vertexTree, dgHullVector *const points, dgInt32 count, dgFloat64 distTol)
void | LinkSibling (dgListNode *node0, dgListNode *node1) const
bool | Sanity () const
dgAABBPointTree4d * | BuildTree (dgAABBPointTree4d *const parent, dgHullVector *const points, dgInt32 count, dgInt32 baseIndex, dgInt8 **const memoryPool, dgInt32 &maxMemSize) const
dgFloat64 | RoundToFloat (dgFloat64 val) const

## Static Protected Member Functions

static dgInt32 | ConvexCompareVertex (const dgHullVector *const A, const dgHullVector *const B, void *const context)

## Protected Attributes

dgInt32 | m_mark
dgInt32 | m_count
dgFloat64 | m_diag
dgArray< dgHullVector > | m_points

## Constructor & Destructor Documentation

## § dgConvexHull4d() [1/2]

dgConvexHull4d::dgConvexHull4d | ( | dgMemoryAllocator *const | allocator,
|  | const dgBigVector *const | vertexCloud,
|  | dgInt32 | count,
|  | dgFloat32 | distTol
| ) |  |

## § ~dgConvexHull4d()

dgConvexHull4d::~dgConvexHull4d | ( | void |  | ) |

virtual

## § dgConvexHull4d() [2/2]

dgConvexHull4d::dgConvexHull4d | ( | dgMemoryAllocator *const | allocator | ) |

protected

## Member Function Documentation

## § AddFace()

dgConvexHull4d::dgListNode * dgConvexHull4d::AddFace | ( | dgInt32 | i0,
|  | dgInt32 | i1,
|  | dgInt32 | i2,
|  | dgInt32 | i3
| ) |  |

protectedvirtual

## § AddVertex()

dgInt32 dgConvexHull4d::AddVertex | ( | const dgBigVector & | vertex | ) |

protectedvirtual

Reimplemented in dgDelaunayTetrahedralization.

## § BuildHull()

void dgConvexHull4d::BuildHull | ( | dgMemoryAllocator *const | allocator,
|  | const dgBigVector *const | vertexCloud,
|  | dgInt32 | count,
|  | dgFloat64 | distTol
| ) |  |

protected

## § BuildNormalList()

dgInt32 dgConvexHull4d::BuildNormalList | ( | dgBigVector *const | normalArray | ) | const

protected

## § BuildTree()

dgAABBPointTree4d * dgConvexHull4d::BuildTree | ( | dgAABBPointTree4d *const | parent,
|  | dgHullVector *const | points,
|  | dgInt32 | count,
|  | dgInt32 | baseIndex,
|  | dgInt8 **const | memoryPool,
|  | dgInt32 & | maxMemSize
| ) |  | const

protected

## § CalculateConvexHull()

void dgConvexHull4d::CalculateConvexHull | ( | dgAABBPointTree4d * | vertexTree,
|  | dgHullVector *const | points,
|  | dgInt32 | count,
|  | dgFloat64 | distTol
| ) |  |

protected

## § ConvexCompareVertex()

dgInt32 dgConvexHull4d::ConvexCompareVertex | ( | const dgHullVector *const | A,
|  | const dgHullVector *const | B,
|  | void *const | context
| ) |  |

staticprotected

## § DeleteFace()

void dgConvexHull4d::DeleteFace | ( | dgListNode *const | node | ) |

protectedvirtual

Reimplemented in dgDelaunayTetrahedralization.

## § FindFacingNode()

dgConvexHull4d::dgListNode * dgConvexHull4d::FindFacingNode | ( | const dgBigVector & | vertex | ) |

protected

## § GetHullVertexArray()

const dgHullVector * dgConvexHull4d::GetHullVertexArray | ( |  | ) | const

inline

## § GetVertex()

const dgBigVector & dgConvexHull4d::GetVertex | ( | dgInt32 | i | ) | const

inline

## § GetVertexCount()

dgInt32 dgConvexHull4d::GetVertexCount | ( |  | ) | const

inline

## § GetVertexIndex()

dgInt32 dgConvexHull4d::GetVertexIndex | ( | dgInt32 | i | ) | const

inline

## § IncMark()

dgInt32 dgConvexHull4d::IncMark | ( |  | ) |

inline

## § InitVertexArray()

dgInt32 dgConvexHull4d::InitVertexArray | ( | dgHullVector *const | points,
|  | const dgBigVector *const | vertexCloud,
|  | dgInt32 | count,
|  | void *const | memoryPool,
|  | dgInt32 | maxMemSize
| ) |  |

protectedvirtual

## § InsertNewVertex()

void dgConvexHull4d::InsertNewVertex | ( | dgInt32 | vertexIndex,
|  | dgListNode *const | frontFace,
|  | dgList< dgListNode *> & | deletedFaces,
|  | dgList< dgListNode *> & | newFaces
| ) |  |

protected

## § LinkSibling()

void dgConvexHull4d::LinkSibling | ( | dgListNode * | node0,
|  | dgListNode * | node1
| ) |  | const

protected

## § RoundToFloat()

dgFloat64 dgConvexHull4d::RoundToFloat | ( | dgFloat64 | val | ) | const

protected

## § Sanity()

bool dgConvexHull4d::Sanity | ( |  | ) | const

protected

## § Save()

void dgConvexHull4d::Save | ( | const char *const | filename | ) | const

## § SupportVertex()

dgInt32 dgConvexHull4d::SupportVertex | ( | dgAABBPointTree4d **const | tree,
|  | const dgHullVector *const | points,
|  | const dgBigVector & | dir
| ) |  | const

protected

## § TessellateTriangle()

void dgConvexHull4d::TessellateTriangle | ( | dgInt32 | level,
|  | const dgVector & | p0,
|  | const dgVector & | p1,
|  | const dgVector & | p2,
|  | dgInt32 & | count,
|  | dgBigVector *const | ouput,
|  | dgInt32 & | start
| ) |  | const

protected

## Member Data Documentation

## § m_count

dgInt32 dgConvexHull4d::m_count

protected

## § m_diag

dgFloat64 dgConvexHull4d::m_diag

protected

## § m_mark

dgInt32 dgConvexHull4d::m_mark

protected

## § m_points

dgArray<dgHullVector> dgConvexHull4d::m_points

protected

The documentation for this class was generated from the following files:

- dynamics.mod/NewtonDynamics/source/core/dgConvexHull4d.h
- dynamics.mod/NewtonDynamics/source/core/dgConvexHull4d.cpp